=== modified file 'NEWS'
--- NEWS	2007-01-24 19:42:26 +0000
+++ NEWS	2007-01-31 18:49:12 +0000
@@ -27,6 +27,9 @@
 
   BUGFIXES:
 
+    * Lock operations no longer hang if they encounter a permission problem.
+      (Aaron Bentley)
+
   TESTING:
 
     * New ``--first`` option to ``bzr selftest`` to run specified tests

=== modified file 'bzrlib/lockdir.py'
--- bzrlib/lockdir.py	2006-11-10 21:06:11 +0000
+++ bzrlib/lockdir.py	2007-01-31 18:49:12 +0000
@@ -220,6 +220,8 @@
             self.transport.rename(tmpname, self._held_dir)
             self._lock_held = True
             self.confirm()
+        except errors.PermissionDenied:
+            raise
         except (PathError, DirectoryNotEmpty, FileExists, ResourceBusy), e:
             mutter("contention on %r: %s", self, e)
             raise LockContention(self)

=== modified file 'bzrlib/tests/test_lockdir.py'
--- bzrlib/tests/test_lockdir.py	2006-09-29 20:12:58 +0000
+++ bzrlib/tests/test_lockdir.py	2007-01-31 18:49:12 +0000
@@ -17,12 +17,14 @@
 """Tests for LockDir"""
 
 from cStringIO import StringIO
+import os
 from threading import Thread, Lock
 import time
 
 import bzrlib
 from bzrlib import (
     config,
+    errors,
     osutils,
     )
 from bzrlib.errors import (
@@ -600,3 +602,10 @@
         ld1.create()
         ld1.lock_write()
         ld1.unlock()
+
+    def test_lock_permission(self):
+        ld1 = self.get_lock()
+        lock_path = ld1.transport.local_abspath('test_lock')
+        os.mkdir(lock_path)
+        osutils.make_readonly(lock_path)
+        self.assertRaises(errors.PermissionDenied, ld1.attempt_lock)

